/* Pseudo device library routines Copyright (C), Lawrence Foard, 1992 
 * May be used under the gnu library license
 * I may be contacted at:
 * lfoard@turing.org, entropy@world.std.com, 
 * entropy on the VWIS Linux support BBS 1-508-793-9568 
 * Snail mail:
 * Lawrence Foard
 * Suite #791
 * 1415 Main st.
 * Worcester ma 01603
 */
#ifndef PSEUDO_LIB_H
#define PSEUDO_LIB_H

typedef struct pseudo PSEUDO;

struct pseudo
 {
  int in_fd,out_fd; /* file handle(s) for device */
  int size; /* reject anything out of range */
  int direct; /* is this talking direct to kernel, or through pipes? */
  int serial; /* serial # */
 };

PSEUDO *open_pseudo(char *device_name);
void close_pseudo(PSEUDO *pseudo);
int size_pseudo(PSEUDO *pseudo,int size);
int run_pseudo(PSEUDO *pseudo,int (*read_fun)(),int (*write_fun)(),void *data);

#endif
