#include <stdio.h>
#include <fcntl.h>
#include <sys/pseudo.h>

#define BSIZE 5000

#define HEADER ((struct pc_header *)buff)

#define MKHEADER(object,cmnd,data)\
 {\
  (object).header.command=cmnd;\
  (object).header.serial=serial++;\
  (object).header.size=sizeof(object)+data;\
 }

main(int argc,char *argv[])
 {
  struct pc_size pc_size;
  int dev_fd,size;
  char *ram;
  char buff[BSIZE];
  int serial=0;
  if (!argv[1] || !argv[2])
   {
    fprintf(stderr,"Usage: [device name] [size in K]\n");
    exit(1);
   }
  if (-1==(dev_fd=open(argv[1],O_RDWR)))
   {
    perror(argv[1]);
    exit(1);
   }
  size=atoi(argv[2])*1024;
  ram=(char *)sbrk(size);
  /* notify kernel of our size */
  MKHEADER(pc_size,PC_SIZE,0);
  pc_size.size=size;
  write(dev_fd,&pc_size,sizeof(pc_size));
  while(1)
   {
    if (-1==read(dev_fd,buff,BSIZE))
     {
      perror("read");
      exit(1);
     }
    switch(HEADER->command)
     {
      case PC_WRITE:
       {
        struct pc_write pc_write=*((struct pc_write *)buff);
        struct pc_w_reply pc_w_reply;
        pc_w_reply.write_req=pc_write;
        MKHEADER(pc_w_reply,PC_W_REPLY,0);
        if (pc_w_reply.actually_wrote=((pc_write.location>=0) && (pc_write.location+pc_write.size)<=size) ? pc_write.size : 0)
         memcpy(ram+pc_write.location,buff+sizeof(pc_write),pc_write.size);
        write(dev_fd,&pc_w_reply,sizeof(pc_w_reply));
/*        fprintf(stderr,"got write request %d\n",pc_write.location);*/
       }
       break;
      case PC_READ:
       {
        struct pc_read pc_read=*((struct pc_read *)buff);
        struct pc_r_reply pc_r_reply;
        pc_r_reply.read_req=pc_read;
        MKHEADER(pc_r_reply,PC_R_REPLY,0);
        if (pc_r_reply.actually_read=((pc_read.location>=0) && (pc_read.location+pc_read.size)<=size) ? pc_read.size : 0)
         {
          MKHEADER(pc_r_reply,PC_R_REPLY,pc_read.size);
          memcpy(buff+sizeof(pc_r_reply),ram+pc_read.location,pc_read.size);
          memcpy(buff,&pc_r_reply,sizeof(pc_r_reply));
          write(dev_fd,buff,sizeof(pc_r_reply)+pc_read.size);
         }
        else
         { 
          MKHEADER(pc_r_reply,PC_R_REPLY,0);
          write(dev_fd,&pc_r_reply,sizeof(pc_r_reply));
         }
/*        fprintf(stderr,"got read request %d\n",pc_read.location);*/
       }
       break;
      default: 
       fprintf(stderr,"unrecognized command\n");
     }
   }
 }
 